local YGS_share_versions = {}
local YGS_new_db_ver = {}

--will be executed when guild addon msg is recived
function YssGuildShop:ReceiveMessageGuild(prefix, distribution, sender, message)
	if sender ~= UnitName("player") then
	if YssGuildShop.db.char.YGS_settings[4] then
		self:Print("data recived from "..sender)
	end
	if message then
		local uniquecheck = 0
		if message == "VR" then
			if YssGuildShop.db.char.YGS_share then
				for k=1,table.maxn(YssGuildShop.db.char.YGS_share) do	
					YGS_share_versions[k] = YssGuildShop.db.char.YGS_share[k]["YGS_ID"]
				end
				YGS_share_versions["VS"] = true				self:SendPrioritizedCommMessage("ALERT","WHISPER", sender, YGS_share_versions)
			end
		elseif message["YGS_ID"] then
			if tonumber(message["YGS_ID"][3]) >= YGS_low_comp_ver then
				if message["YGS_ID"][1] ~= UnitName("player") then
					if YssGuildShop.db.char.YGS_share~= nil and YssGuildShop.db.char.YGS_share ~= {} then
						for k=1,table.maxn(YssGuildShop.db.char.YGS_share) do
							if YssGuildShop.db.char.YGS_share[k]["YGS_ID"][1] == message["YGS_ID"][1] then
								if YssGuildShop.db.char.YGS_share[k]["YGS_ID"][2] < message["YGS_ID"][2] then
									YssGuildShop.db.char.YGS_share[k] = message
									if YssGuildShop.db.char.YGS_settings[4] then
										self:Print("data recived from "..sender.." about "..message["YGS_ID"][1])
									end
								end
								uniquecheck = 1
							end
						end
						if uniquecheck == 0  then
							YssGuildShop.db.char.YGS_share[table.maxn(YssGuildShop.db.char.YGS_share)+1] = message
							if YssGuildShop.db.char.YGS_settings[4] then
								self:Print("data recived from "..sender.." about "..message["YGS_ID"][1])
							end
						end
					else
						YssGuildShop.db.char.YGS_share = {}
						YssGuildShop.db.char.YGS_share[1] = message
						if YssGuildShop.db.char.YGS_settings[4] then
							self:Print("data recived from "..sender.." about "..message["YGS_ID"][1])
						end
					end
				end
			else
				if YssGuildShop.db.char.YGS_settings[4] then
					self:Print(sender.." send data from incompatible version")
				end
				--SendChatMessage("Your YssGuildShop version is out of date! Current version is "..GetAddOnMetadata("YssGuildShop", "Version"), "WHISPER", nil,sender)
			end
		elseif message["YGS_AC"] then
			for itemID, value in pairs(message) do
				if value[1] == "no value set" then
					YssGuildShop_share_value(itemID)
				else
					YssGuildShop_share_value(itemID, value[1], value[2])
				end
			end
		end
	end
	end
end

function YssGuildShop:ReceiveMessageWhisper(prefix, distribution, sender, message)
	if sender ~= UnitName("player") then
	if YssGuildShop.db.char.YGS_settings[4] then
		self:Print("ReceiveMessageWhisper exe")
	end
	if message then
		if message["VS"] then
			if table.maxn(YGS_new_db_ver) ~= 0 then
				for k=1,table.maxn(message) do
					for j=1, table.maxn(YGS_new_db_ver) do
						--self:Print("prefilter: "..message[k][1] .. " " .. message[k][2] .. " " .. sender)
						if YGS_new_db_ver[j][1] == message[k][1] and YGS_new_db_ver[j][2] < message[k][2] and message[k][1] ~= UnitName("player") then
							--self:Print("postfilter: "..message[k][1] .. " " .. message[k][2] .. " " .. sender)
							YGS_new_db_ver[j] = {message[k][1],message[k][2],sender}
						end
					end
				end
			else
				for k=1,table.maxn(message) do
					YGS_new_db_ver[k] = {message[k][1],message[k][2],sender}
				end
			end
		else
			if YssGuildShop.db.char.YGS_share ~= nil and YssGuildShop.db.char.YGS_share ~= {} then
				for k=1,table.maxn(YssGuildShop.db.char.YGS_share) do
					if YssGuildShop.db.char.YGS_share[k]["YGS_ID"][1] == message[1] then
						self:SendPrioritizedCommMessage("BULK","GUILD",YssGuildShop.db.char.YGS_share[k])
					end
				end
			end
		end
	end
	end
end

function YssGuildShop:YGS_RequestDB()
	local packet= {}
	if table.maxn(YGS_new_db_ver) ~= 0 then
		for j=1, table.maxn(YGS_new_db_ver) do
			packet[1] = YGS_new_db_ver[j][1]
			packet["VS"] = false
			self:SendPrioritizedCommMessage("BULK","WHISPER", YGS_new_db_ver[j][3], packet)
		end
	end
	if YssGuildShop.db.char.YGS_settings[4] then
		self:Print("RequestDB exe")
	end
end

-- sends only own sharable data
function YssGuildShop:Send()
	if YGS_timestamp() - YGS_sending >= 10 then
		if YssGuildShop.db.account.YGSDB~= nil and YssGuildShop.db.account.YGSDB ~= {} then
			for k=1,table.maxn(YssGuildShop.db.account.YGSDB) do
				if YssGuildShop.db.account.YGSDB[k]["YGS_ID"][1] == UnitName("player") and YssGuildShop.db.account.YGSDB[k]["YGS_ID"][4] == GetRealmName() then
					local YGS_personal_send = {}
					for key, value in ipairs(YssGuildShop.db.account.YGSDB[k]) do
						if YssGuildShop.db.char.YGS_share_filter[value[1]]then
							YGS_personal_send[key] = value
						end
					end
					YGS_personal_send["YGS_ID"] = YssGuildShop.db.account.YGSDB[k]["YGS_ID"]
					self:SendPrioritizedCommMessage("BULK","GUILD",YGS_personal_send)
					if YssGuildShop.db.char.YGS_settings[4] then
						self:Print(YGS_timestamp() - YGS_sending .. " sec since last send") -- debug line
					end
					YGS_sending = YGS_timestamp()
				end
			end
		end
		if YssGuildShop.db.char.YGS_value ~= nil and YssGuildShop.db.char.YGS_value ~= {} then
			self:SendPrioritizedCommMessage("BULK","GUILD",YssGuildShop.db.char.YGS_value)
		end
	end	
end

-- sends version request
function YssGuildShop:Send_VR()
	self:SendPrioritizedCommMessage("ALERT","GUILD","VR")
	YGS_new_db_ver = {}
	YssGuildShop:RemoveTimer("VR")
	YssGuildShop:AddTimer("VR", 10, "YGS_RequestDB")
end
